<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<!--
DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.

 * Copyright © 1997, 2011, Oracle and/or its affiliates. All rights reserved.
 * Use is subject to license terms.
-->

        <title>Generating Database Tables at Deployment</title>

        <link rel="StyleSheet" href="nbdocs://org.netbeans.modules.usersguide/org/netbeans/modules/usersguide/ide.css" type="text/css">
    </head>

    <body>
        <h2>Generating Database Tables at Deployment</h2>

        <p><small><a href="#seealso">See Also</a></small></p>

        <p>When developing CMP entity beans, if your only requirement is that the beans
            are persisted to a database and you are not particular about the structure of
            the database, you can configure the application such that the database and mappings
            will be generated by the application server. In this case, you can create your
            CMP entity beans, the bean fields, and the relationships in the IDE. You then
            configure the application to generate the database tables and mappings when
            you deploy the application.</p>

        <ul class="note">
            <li>Unless you <a href="../../../ejb/editing/generate_cmp_beans.html">create
                entity beans from a database connection</a>, the IDE assumes you want to generate
                the <tt>sun-cmp-mappings.xml</tt> file automatically. If you create CMP entity
                beans using the <a href="../../../ejb/csh/ejb_new_entity.html">New
                Entity Bean template</a> and manually set up your mappings by hand in a <tt>sun-cmp-mappings.xml</tt>
                file, the IDE ignores your settings and configures the mappings during deployment.
                To use your own <tt>sun-cmp-mappings.xml</tt> file, generate a CMP entity bean
                from any database. You can then delete the bean. The IDE automatically switches
                your project to pick up the existing <tt>sun-cmp-mappings.xml</tt> file.</li>
        </ul>

        <p><b>To generate database tables at runtime:</b></p>

        <ol>
            <li>Make sure that your entity beans are set to use container-managed persistence
                and have their CMP fields and container-managed relationships correctly configured.</li>
            <li>In the Projects window, expand Configuration Files and double-click <tt>sun-ejb-jar.xml</tt>
                to open the file in the Visual Editor.</li>
            <li>Click the XML tab to open the XML editor.</li>
            <li>Specify the JNDI name for your database resource in the <tt>&lt;jndi-name&gt;</tt> property.
                Make sure that the name matches a database resource configured on your application server.</li>
            <li>Set the value of the &lt;create-tables-at-deploy&gt; element to True.
                <p>To prevent an error when redeploying the application, set Drop Table At
                    Undeployment to True. Alternatively, you can delete the tables manually
                    in the Services window of the IDE.</li>
            <li>Make sure the database server in which you are generating the tables is
                running. If you are using the bundled Java DB server, expand the Databases node
                in the Servers window and right-click the Java DB node and choose Start Server.</li>
            <li>Deploy your application by right-clicking the project node and choosing Run. </li>
        </ol>

        <p>When you click Run, a table is generated for each CMP bean. In each table, a
            column is created for each CMP field and the relationships between the tables
            are generated based upon the relationships between your CMP beans. You can see
            the created tables under the Tables node for your database connection in the
            Services window.</p>

        <dl>
            <dt>See Also<a name="seealso"></a></dt>
            <dd><a href="../../../ejb/general/about_cmp.html">About EJB 2.1 CMP Mappings</a></dd>
            <dd><a href="../../../ejb/editing/define_cmp_field.html">Defining a CMP Field</a></dd>
            <dd><a href="map_rel_fields.html">Mapping Relationship Fields</a> </dd>
            <dd><a href="../../../ejb/editing/generate_cmp_beans.html">Generating CMP Entity Beans from a Database</a></dd>
            <dd><a href="map_bean_to_db.html">Configuring CMP Mappings</a></dd>
        </dl>

        <hr>
        <small><a href="../../../credits.html">Legal Notices</a></small> 

        <table cellpadding="50" border="0">
            <tr><td>&nbsp;</td></tr>
        </table>

    </body>
</html>